unit CNamer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DSGNINTF;


Type
  EComponentNamerError = class(Exception);

  TComponentNamer = Class(TComponent)
  Private
    FNameValue    : String;
    FNameMin      : Integer;
    FComponentList: TStringList;
    FChangeNames  : Boolean;
    Procedure SetComponenter(Value : TStringList);
    Function GetFComponentList : TStringList;
    Function TypeExist(Listen : TStringList;CheckNavn : String) : Boolean;
  protected
    destructor Destroy; override;
  Public
    constructor Create(AOwner: TComponent); override;
  published
    Property Componenter: TStringList Read GetFComponentList Write SetComponenter;
//    Property NamesValue : String  Read FNameValue Write FNameValue;
//    Property MinValue   : Integer Read FNameMin Write FNameMin;
  End;

procedure Register;

implementation

procedure Error(Text: string);
var
  StackTop: record end;
  Stack: record
    EBP: Integer;
    ReturnAddress: Pointer;
  end absolute StackTop;
begin
  raise EComponentNamerError.Create(Text) at Stack.ReturnAddress;
end;

Destructor TComponentNamer.Destroy;
Begin
  FComponentList.Free;
  Inherited;
End;

constructor TComponentNamer.Create(AOwner: TComponent);
Var
  i: Integer;
Begin
  if not (AOwner is TForm) then
    Error('Componentnamer Owner has to be a form!')
  else with AOwner do Begin
    for i := 0 to ComponentCount-1 do Begin
      if Components[i] is TComponentNamer then
        Error('Only one instance of ComponentNamer');
    End;
  End;
  FComponentList := TStringList.Create;
  inherited Create(AOwner);
End;

Function TComponentNamer.TypeExist(Listen : TStringList;CheckNavn : String) : Boolean;
Var I : Integer;
Begin
  Result := TRUE;
  For I := 0 To Listen.Count-1 Do Begin
    If Listen[I]=CheckNavn then Exit;
  End;
  Result := False;
End;

Function TComponentNamer.GetFComponentList : TStringList;
Var
  I,Y : Integer;
  TypeList : TStringList;
Begin
  TypeList := TStringList.Create;
  FComponentList.Clear;
  With Owner Do Begin
    For I := 0 To ComponentCount-1 Do Begin
      If Not TypeExist(TypeList, Components[I].ClassName) Then
        TypeList.Add(Components[I].ClassName);
    End;
    For I := 0 To TypeList.Count-1 Do Begin
      FComponentList.Add(TypeList[I]);
      For Y := 0 To ComponentCount-1 Do Begin
        If Components[Y].ClassName = TypeList[I] Then
          FComponentList.Add(#9+Components[Y].Name);
      End;
    End;
  End;
  Result := FComponentList;
End;

Procedure TComponentNamer.SetComponenter(value : TStringList);
Begin
  FComponentList.Assign(Value);
End;

procedure Register;
Begin
  RegisterComponents ('Jimmys', [TComponentNamer] );
End;

end.
